Codeforces #263 div2 解题报告

比赛链接:http://codeforces.com/contest/462

这次比赛的时候,刚刚注册的时候很想好好的做一下,但是网上喝了个小酒之后,也就迷迷糊糊地看了题目,做了几题,一觉醒来发现rating掉了很多,那个心痛啊!

不过,后来认真的读了题目,发现这次的div2并不是很难!

官方题解:http://codeforces.com/blog/entry/13568

A. Appleman and Easy Task

解析:

一个水题,判断每个细胞周围是否都是有偶数个相邻细胞。

 

代码:

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
using namespace std;
#define Lowbit(x) ((x)&(-(x)))
#define ll long long
#define mp make_pair
#define ff first
#define ss second
#define pb push_back
const int MAXN=1005;

ll a[30];
int n;
char str[105][105];

bool check(int i, int j){
    int tmp = 0;
    if(i>0&&str[i-1][j]=='o')
        ++tmp;
    if(i<n-1&&str[i+1][j]=='o')
        ++tmp;
    if(j>0&&str[i][j-1]=='o')
        ++tmp;
    if(j<n-1&&str[i][j+1]=='o')
        ++tmp;
    if(tmp%2)
        return false;
    return true;
}

int main(){
    #ifdef LOCAL
        freopen("1.in", "r",stdin);
        //freopen("1.out", "w", stdout);
    #endif

    int i,j;
    scanf("%d", &n);
    for(i=0; i<n; ++i){
        scanf("%s", str[i]);
    }
    bool flag = true;

    for(i=0; i<n&&flag; ++i){
        for(j=0; j<n&&flag; ++j){
            if(!check(i,j)){
                flag = false;
                break;
            }
        }
    }

    printf("%s", flag?"YES":"NO");
    return 0;
}

B. Appleman and Card Game

解析:

       
两个水题,贪心问题,直接统计每个字母出现的次数,然后sort一下,每次取最大的。

       但是,这里要注意一下数据范围,结果用long long表示,在计算过程中需要强制类型转换,尤其k在计算中一定要是long long型

代码:

//#define LOCAL
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
using namespace std;
#define Lowbit(x) ((x)&(-(x)))
#define ll long long
#define mp make_pair
#define ff first
#define ss second
#define pb push_back
const int MAXN=1005;

ll a[30];
char str[100010];

int main(){
    #ifdef LOCAL
        freopen("1.in", "r",stdin);
        //freopen("1.out", "w", stdout);
    #endif

    int n;
    ll k;
    scanf("%d%I64d", &n, &k);
    scanf("%s", str);
    int len = strlen(str);
    memset(a, 0, sizeof(a));
    for(int i=0; i<n; ++i){
        a[str[i]-'A']++;
    }
    sort(a,a+26);
    ll sum = 0;
    for(int i=25; i>=0&&k>0; --i){
        if(k>=a[i]){
            sum += a[i]*a[i];
            k -= a[i];
        }
        else{
            sum += k*k;
            k-=k;
        }
    }
    printf("%I64d\n", sum);
    return 0;
}

C. Appleman and Toastman

解析:

       三个水题,贪心嘛,每次将最小的那个数字单独拆开,可以用sort也可以用priority_queue。

 

代码:

//#define LOCAL
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
using namespace std;
#define Lowbit(x) ((x)&(-(x)))
#define ll long long
#define mp make_pair
#define ff first
#define ss second
#define pb push_back
const int MAXN=1005;

int main(){
    #ifdef LOCAL
        freopen("1.in", "r",stdin);
        //freopen("1.out", "w", stdout);
    #endif

    int i,n;
    ll sum = 0;
    ll score = 0,tmp;
    priority_queue< ll, vector<ll>, greater<ll> >pq;
    scanf("%d", &n);
    for(i=0; i<n; ++i){
        scanf("%I64d", &tmp);
        sum += tmp;
        pq.push(tmp);
    }

    score = sum;
    while(pq.size()>1){
        score += sum;
        tmp = pq.top();
        pq.pop();
        sum -= tmp;
    }
    printf("%I64d", score);

    return 0;
}

D. Appleman and Tree

解析:

       这是一道DP问题,用到树形DP;

       题意:给了一棵树以及每个节点的颜色,1代表黑,0代表白,要求的是,如果将这棵树拆成k棵树,使得每棵树恰好有一个黑色节点

       

       dp[v][0 ]表示以v为根没有黑节点子树的数目

       dp[v][1] 表示以v为根有黑节点子树的数目

 

       说实话,我遇到DP还是比较犯怵的,所以在比赛的时候发现这是道DP问题,也就懒得在动用喝醉的大脑了,直接GG了。

 

代码:

//#define LOCAL
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
using namespace std;
#define Lowbit(x) ((x)&(-(x)))
#define ll long long
#define mp make_pair
#define ff first
#define ss second
#define pb push_back
#define mod 1000000007
const int MAXN=100010;

ll dp[MAXN][2];
vector<int> x[MAXN];
int c[MAXN];

void dfs(int v,int p){
    dp[v][0] = 1;
    dp[v][1] = 0;
    for(int i=0; i<x[v].size(); ++i){
        int u = x[v][i];
        if(u == p)    continue;
        dfs(u,v);
        dp[v][1] = ((dp[v][1]*dp[u][0])%mod+(dp[v][0]*dp[u][1])%mod)%mod;
        dp[v][0] = (dp[v][0]*dp[u][0])%mod;
    }
    if(c[v])    dp[v][1] = dp[v][0];
    else    dp[v][0] =(dp[v][0]+dp[v][1])%mod;
}

int main(){
    #ifdef LOCAL
        freopen("1.in", "r",stdin);
        //freopen("1.out", "w", stdout);
    #endif

    int tmp;
    int n;
    scanf("%d", &n);
    for(int i=1; i<n; ++i){
        scanf("%d", &tmp);
        x[i].pb(tmp);
        x[tmp].pb(i);
    }
    for(int i=0; i<n; ++i){
        scanf("%d", &c[i]);
    }
    dfs(0,-1);
    printf("%I64d", dp[0][1]);
    return 0;
}

E. Appleman and a Sheet of Paper

解析:

       说实话这个题目根本不需要怎么多读,直接看样例的分析就知道题意了。就是简单的叠纸条,然后查询区间的纸条总厚度

        这里可以用BIT(树状数组),也可以用线段树。

       这里的代码,我用的是树状数组。

       本题解答的一个巧妙的地方就是,如果左边叠的长,那么我们可以反过来把右边的叠过来,但是纸条的左右方向要转向,所以这里用了一个flag标记左右的方向。其他部分就和普通的树状数组是一样的做法。

代码:

//#define LOCAL
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
using namespace std;
#define Lowbit(x) ((x)&(-(x)))
//#define ll long long
#define mp make_pair
#define ff first
#define ss second
#define pb push_back
#define mod 1000000007
const int MAXN=100010;

int c[MAXN], s[MAXN],n;

void ADD(int p, int val){
    s[p] += val;
    while(p<=n){
        c[p] += val;
        p += Lowbit(p);
    }
}

int getsum(int p){
    int sum = 0;
    while(p>0){
        sum += c[p];
        p -= Lowbit(p);
    }
    return sum;
}

int main(){
    #ifdef LOCAL
        freopen("1.in", "r",stdin);
        //freopen("1.out", "w", stdout);
    #endif

    int i, p;
    scanf("%d%d", &n, &p);
    memset(c, 0, sizeof(c));
    memset(s, 0, sizeof(s));
    for(i=1; i<=n; ++i)
        ADD(i, 1);

    int l=1, r=n;
    int x,y,z;
    int flag = 0;
    for(int k=0; k<p; ++k){
        scanf("%d", &x);
        if(x == 1){
            scanf("%d", &y);
            int fg = ((y*2)>(r-l+1));
            int mid;
            if(flag)    mid = r-y;
            else     mid = l+y-1;

            int ll = mid-l+1; int rr = r-mid;
            if(ll<=rr){
                for(i=l; i<=mid; ++i)
                    ADD(2*mid+1-i, s[i]);
                l = mid+1;
            }
            else{
                for(i=mid+1; i<=r; ++i)
                    ADD(2*mid+1-i, s[i]);
                r = mid;
            }
            flag ^= fg;     //标记,如果左边长,那么就向左叠,并且从右向左读;
                            //如果左边短,那么就向右叠,并且从左向右读。
        }
        else{
            scanf("%d%d", &y,&z);
            if(flag)    printf("%d\n", getsum(r-y)-getsum(r-z));
            else    printf("%d\n", getsum(l+z-1)-getsum(l+y-1));
        }
    }
    return 0;
}
时间: 2024-10-26 02:06:07

Codeforces #263 div2 解题报告的相关文章

cf#263 div2 解题报告

A:要求是否全部的字符都挨着偶数个'o',要读题啊....各种读错题... #include <cstdio> using namespace std; char maz[101][101]; int n; int cnt[101][101]; const int dx[4]={0,0,-1,1}; const int dy[4]={1,-1,0,0}; int main(){ scanf("%d",&n); gets(maz[0]); for(int i=0;i&

cf#261 div2 解题报告

.....代码没什么可说的,主要是学习各路大神姿势 A题 化简化简水题,都告诉平行坐标轴了,数据还出了对角线,后面两个点坐标给的范围也不错 ........和最优代码相比姿势有点混乱 #include <cstdio> int x[4],y[4]; int abs(int n){ return n<0?-n:n; } int main(){ scanf("%d%d%d%d",x,y,x+1,y+1); int dx=abs(x[0]-x[1]); int dy=abs

Codeforces Round#320 Div2 解题报告

Codeforces Round#320 Div2 先做个标题党,骗骗访问量,结束后再来写咯. codeforces 579A Raising Bacteria codeforces 579B Finding Team Member codeforces 579C A Problem about Polyline codeforces 579D "Or" Game codeforces 579E Weakness and Poorness codeforces 579F LCS Aga

codeforces 499B.Lecture 解题报告

题目链接:http://codeforces.com/problemset/problem/499/B 题目意思:给出两种语言下 m 个单词表(word1, word2)的一一对应,以及 professor's lecture 的 n 个单词.问记下来的笔记是什么.对于professor's lecture 的某个单词,如果在单词表中找到,word1, word2 都有可能.如果 word1 的长度  <= word2 的长度,就输出word1,否则word2 考了map<string, st

Topcoder SRM632 DIV2 解题报告

250:乱搞 解题代码: 1 // BEGIN CUT HERE 2 /* 3 4 */ 5 // END CUT HERE 6 #line 7 "RunningAroundPark.cpp" 7 #include <cstdlib> 8 #include <cctype> 9 #include <cstring> 10 #include <cstdio> 11 #include <cmath> 12 #include <

codeforces 490B.Queue 解题报告

题目链接:http://codeforces.com/problemset/problem/490/B 题目意思:给出每个人 i 站在他前面的人的编号 ai 和后面的人的编号 bi.注意,排在第一个位置的人他前面是无人的!于是 a1 = 0.最后那个人的后面是木有人的,即 bn = 0.然后根据这些条件求出整个序列是如何排的,输出答案. 这条题卡了好久.........啊........啊........啊 首先很容易知道第二个位置的人的编号 和 倒数第二个人的位置编号.用一个aft[]数组记录

Topcoder SRM631 DIV2 解题报告

250:网格有两种颜色,网格中一列最长的连续的颜色相同的最大值. 解题思路:暴力. 解题代码: // BEGIN CUT HERE /* */ // END CUT HERE #line 7 "TaroGrid.cpp" #include <cstdlib> #include <cctype> #include <cstring> #include <cstdio> #include <cmath> #include <

Codeforces 474(#270) 解题报告

A:直接贴过来装换 解题代码 1 // File Name: a.cpp 2 // Author: darkdream 3 // Created Time: 2014年10月06日 星期一 23时28分57秒 4 5 #include<vector> 6 #include<list> 7 #include<map> 8 #include<set> 9 #include<deque> 10 #include<stack> 11 #inc

codeforces 495C. Treasure 解题报告

题目链接:http://codeforces.com/problemset/problem/495/C 题目意思:给出一串只有三种字符( ')','(' 和 '#')组成的字符串,每个位置的这个字符 '#'可以替换成不少于 1 个的 ')',问如何对每个'#'进行替换,使得对于字符串的任意一个位置, ')' 的数量始终不大于'(' 的数量.注意,'#'被替换成')'的总数以及原先有的')'的数量之和 == '(' 的总数. 花了两个晚上的一点时间,今天在图书馆里终于想到解决方案了,大感动 ~~~